import { ClientDocuments } from '@graphback/codegen-client';
import { GraphbackGeneratorConfig } from '@graphback/core';
import { GraphbackDataProvider, RuntimeResolversDefinition } from "@graphback/runtime";
import { SchemaProvider } from 'graphql-migrations';
import { PubSub } from 'graphql-subscriptions';
import { IGraphQLBackend } from '.';
/**
 * GraphQLBackend
 *
 * Automatically generate your database structure resolvers and queries from graphql types.
 * See README for examples
 */
export declare class GraphQLBackendCreator {
    private inputContext;
    /**
     * @param graphQLSchema string containing graphql types
     * @param config configuration for backend generator
     */
    constructor(schemaContext: SchemaProvider, config: GraphbackGeneratorConfig);
    /**
     * Create backend with all related resources
     */
    createBackend(database: string): Promise<IGraphQLBackend>;
    /**
     * Create runtime for backend in form of the schema string and resolve functions
     */
    createRuntime(db: GraphbackDataProvider, pubSub: PubSub): Promise<RuntimeResolversDefinition>;
    createClient(): Promise<ClientDocuments>;
}
